#ifndef CATS_DIMENSIONS_H
#define CATS_DIMENSIONS_H

#include "memory/arrays.h"
#include "assert.h"


static inline bool valid_coordinates(const struct cats_dimension *dim, cats_dt_coord row, cats_dt_coord col)
{
        assert(dim != NULL);
        assert(row >= 0 && row < dim->rows);
        assert(col >= 0 && col < dim->cols);
        if (row < 0 || col < 0) return false;
        if (row >= dim->rows || col >= dim->cols) return false;
        return true;
}


void copy_dimensions_from_to(const struct cats_dimension *from, struct cats_dimension *to);

bool dimensions_match(const struct cats_dimension *dim1, const struct cats_dimension *dim2);

bool valid_coordinates(const struct cats_dimension *dim, cats_dt_coord row, cats_dt_coord col);

#endif //CATS_DIMENSIONS_H
